#include"cmplr_constant.hpp"




Constant::
Constant():
data_number(0),
array(nullptr)
{
}


Constant::
Constant(int  i):
data(i),
data_number(1),
array(nullptr)
{
}


Constant::
Constant(std::vector<Constant>&  ls)
{
  data_number = ls.size();

  array = new Constant[data_number];

  auto  dst = array;

    for(auto&&  cs: ls)
    {
      *dst++ = std::move(cs);
    }
}


Constant::
Constant(const std::u16string&  s)
{
  data_number = s.size()+1;

  array = new Constant[data_number];

  auto  dst = array;

    for(auto&  c: s)
    {
      *dst++ = Constant(c);
    }


  *dst = Constant(0);
}


Constant::
Constant(const Constant&   rhs):
array(nullptr)
{
  *this = rhs;
}


Constant::
Constant(Constant&&  rhs) noexcept:
array(nullptr)
{
  *this = std::move(rhs);
}


Constant::
~Constant()
{
  clear();
}




Constant&
Constant::
operator=(const Constant&   rhs)
{
  clear();

  data = rhs.data;

  data_number = rhs.data_number;

  array = rhs.duplicate_array();

  return *this;
}


Constant&
Constant::
operator=(Constant&&  rhs) noexcept
{
  clear();

  data = rhs.data;

  data_number = rhs.data_number;

  array = rhs.array          ;
          rhs.array = nullptr;

  return *this;
}


bool
Constant::
is_empty() const
{
  return(!data_number);
}


bool
Constant::
is_data() const
{
  return(!array && (data_number == 1));
}


bool
Constant::
is_array() const
{
  return(data_number > 1);
}


int
Constant::
get_data() const
{
  return data;
}


void
Constant::
clear()
{
  data_number = 0;

  delete[] array          ;
           array = nullptr;
}


Constant*
Constant::
duplicate_array() const
{
    if(!array)
    {
      return nullptr;
    }


  auto  ptr = new Constant[data_number];

    for(int  i = 0;  i < data_number;  ++i)
    {
      ptr[i] = array[i];
    }


  return ptr;
}


void
Constant::
print(FILE*  f) const
{
  std::string  s;

  print(s);

    for(auto  c: s)
    {
      fputc(c,f);
    }
}


void
Constant::
print(std::string&  buf) const
{
    if(array)
    {
      buf += "{";

      auto   it = array            ;
      auto  end = array+data_number;

      it++->print(buf);

        while(it != end)
        {
          buf += ",";

          it++->print(buf);
        }


      buf += "}";
    }

  else
    if(data_number)
    {
      buf += std::to_string(data);
    }
}




