#include"cmplr_declaration.hpp"
#include"cmplr_function.hpp"




Declaration::
Declaration():
storage_kind(StorageKind::null),
offset(0)
{
}


Declaration::
Declaration(Function*  fn):
storage_kind(StorageKind::global),
type(fn),
literal(fn),
name(fn->name)
{
}


Declaration::
Declaration(const Parameter&  para, size_t  off):
storage_kind(StorageKind::parameter),
offset(off),
type(para.type),
name(para.name)
{
}


Declaration::
Declaration(const mkf::Node&  src, PreContext&  prectx):
storage_kind(StorageKind::null),
offset(0)
{
  read(src,prectx);
}




bool
Declaration::
operator==(StorageKind  stkind) const
{
  return storage_kind == stkind;
}




void
Declaration::
print(FILE*  f) const
{
    switch(storage_kind)
    {
  case(StorageKind::local_static):
      fprintf(f,"static ");
  case(StorageKind::local):
  case(StorageKind::global):
      break;
    }


  type.print(f);

  fprintf(f,"  %s = ",name.data());

  literal.print(f);
}




