#include"cmplr_declaration.hpp"
#include"cmplr_context.hpp"




Type
Declaration::
compile_initialize(Context&  ctx) const
{
    switch(storage_kind)
    {
      case(StorageKind::local):
        compile_use(ctx);

        literal.compile_value(ctx);

        type.compile_assign(ctx);

        return type.make_reference();
        break;
      case(StorageKind::local_static):
        break;
      case(StorageKind::global):
        break;
      case(StorageKind::parameter):
        break;
    }


  return Type();
}


Type
Declaration::
compile_use(Context&  ctx) const
{
    switch(storage_kind)
    {
      case(StorageKind::local):
        ctx.push("  pshbp        ;//---------------------------------//\n");
        ctx.push("  psh16u %6d;//ローカル変数%sのアドレスを読み出し//\n",offset,name.data());
        ctx.push("  sub          ;//---------------------------------//\n");

        return type.make_reference();
        break;
      case(StorageKind::local_static):
        ctx.push("  psh16u _STATIC_%06z;//%s\n",offset,name.data());

        return type.make_reference();
        break;
      case(StorageKind::global):
        ctx.push("  psh16u %s;\n",name.data());

        return type.make_reference();
        break;
      case(StorageKind::parameter):
        ctx.push("  pshbp        ;//-------------------------//\n");
        ctx.push_psh(offset,"//実引数%sのアドレス読み出し//\n",name.data());
        ctx.push("  add          ;//-------------------------//\n");

        return type.make_reference();
        break;
    }


  return Type();
}


void
Declaration::
compile_data(Context&  ctx) const
{
    switch(storage_kind)
    {
      case(StorageKind::local_static):
        ctx.push_definition("_STATIC_%06z://%s\n",offset,name.data());

        literal.compile_data(type,ctx);
        break;
      case(StorageKind::global):
        ctx.push_definition("%s:\n",name.data());

        literal.compile_data(type,ctx);
        break;
    }
}




